Attribute VB_Name = "modSimplex"
'============================================================
' Descrizione.....: Subroutine SIMPLEX
' Nome dei Files..: modSimplex.bas, frmSimplexOp.frm
' Data............: 28/07/1999
' Versione........: 1.0 a 32 bits.
' Sistema.........: Visual Basic 6.0 sotto Windows NT 4.0
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.it/flanguasco/
'============================================================
'
Option Explicit
'
' Variabili specifiche per questo caso di SIMPLEX:
Private HSx#()
Private GRs#(), FRs#()
'
Private FrqSx#()    ' Vettore dei punti di Frequenza a cui valutare:
Private FxSx#()     '  il Profilo Desiderato dello Spettro
                    '  di Ampiezza, usando
Private WxSx#()     '  il Profilo di Pesatura.
'
'----------------------------------------------------------------------
'
Private VERMAT#()            ' Vettori e Matrici usati da SIMPLEX.
Private CENTRE#()            '    "         "      "         "
Private VERVAL#()            '    "         "      "         "
Private NPAR&                ' Variabili usate da SIMPLEX.
Private NVERT&               '    "         "      "
'
Private Const alfa# = 1#     ' Coefficiente di Riflessione.
Private Const BETA# = 0.5    ' Coefficiente di Contrazione.
Private Const GAMMA# = 2#    ' Coefficiente di Riflessione Estesa.
Private Const DELTA# = 0.5   ' Coefficiente di Contrazione Completa.
Private Function VERCALC(ByVal ICALCV&) As Double
'
'   Caso Sintesi di FIR:
'   La funzione da minimizzare e' la somma degli errori al quadrato.
'   Gli errori sono le distanze, alle frequenze definite in FrqSx(F),
'   della risposta voluta FxSx(F) da quella calcolata GRs(F), corretti
'   con la funzione peso WxSx(F).
'
    Dim IP&, F&, DisQ#
'
    For IP = 1 To NPAR
        HSx(IP - 1) = VERMAT(ICALCV, IP)
    Next IP
'
    RispostaH HSx(), FrqSx(), GRs(), FRs()
'
    For F = 0 To UBound(FrqSx)
        DisQ = DisQ + WxSx(F) * (GRs(F) - FxSx(F)) * (GRs(F) - FxSx(F))
    Next F
'
    VERCALC = DisQ
'
'
'
End Function
Sub SIMPLEX(IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, _
    NCiclo&, NCC&, OpS$, BestP#())
'
'   Program SIMPLEX
'   ---------------
'
'   Versioni FORTRAN:
'   1F) F. Languasco - 3M Italia, Ferrania - 1/6/84
'       da: - "Fitting curves to data: the Simplex algorithm
'             is the answer", di Cacaceci e Cacheris. Byte, May 1984.
'           - "A Simplex method for function minimization"
'             di J. Nelder, R. Mead. The Computer Journal, Jan 1965.
'
'   2F) by F. G. Languasco - Unilever Research, Bromham - 19/Jul/88
'
'   Versione 1.0 del programma in VB 3.0.
'   Tradotto dal FORTRAN il 31/5/1995.
'
'   Versione 1.0 del programma in VB 6.0 del 28/7/1999.
'   La stretta discendenza da un programma FORTRAN (collaudato per
'   anni) scusera' l' uso dei "GoTo", cosi' invisi ai puristi.
'
'   Programma di ricerca del minimo.
'   Deve essere preceduto, per l' impostazione delle condizioni
'   iniziali, da una chiamata ad un' opportuna versione di SIMPLES.
'
'   Definizioni & Dati (vedi SchemaMatrici):
'   ----------------------------------------
'
'   VERMAT#(0 To V&, 1 To P&) > Matrice dei vertici: P e' il numero di
'                               parametri della funzione che si vuole
'                               minimizzare con una opportuna scelta
'                               dei loro valori.
'                               V = P + 1 e' il mumero di vertici a P
'                               dimensioni del simplesso.
'                               Il vertice 0 (IV0) e' usato come memoria
'                               temporanea di un Set di parametri
'                               risultanti da una operazione di ricerca.
'
'   VERVAL#(0 To V&)          > Vettore dei valori della funzione da
'                               minimizzare calcolati ai V& vertici.
'
'   CENTRE#(1 To P&)          > Vettore dei P valori medi dei parametri
'                               calcolati su V& - 1 vertici:
'                               il vertice escluso e' IWORSTV.
'
'   VERCALC#(IV&)               Routine di calcolo della funzione da
'                               minimizzare usando i parametri cor-
'                               rispondenti al vertice IV&.
'
'   Valori ritornati:
'   -----------------
'
'   IBESTV&                   > Numero del vertice migliore.
'   IWORSTV&                  > Numero del vertice peggiore.
'
'   ValBV#                    > Valore della funzione da minimizzare
'                               calcolato al vertice migliore.
'   ValWV#                    > Valore della funzione da minimizzare
'                               calcolato al vertice peggiore.
'   ValDf#                    > Differenza tra i due valori precedenti.
'
'   NCiclo&                   > Numero del ciclo di ricerca corrente.
'   NCC&                      > Numero di operazioni consecutive di
'                               "Contrazione Completa".
'   OpS$                      > Nome dell' operazione effettuata nel
'                               ciclo corrente.
'
'   BestP#(.. To ..)          > Vettore dei migliori parametri trovati.
'
'----------------------------------------------------------------------------
'
    Dim IV&, IP&, IBP&, CENVAL#
'
'   Algoritmo 'SIMPLEX' di ricerca del Minimo
'   -----------------------------------------
'
    NCiclo = NCiclo + 1
'
    ' Calcola il valor medio dei parametri:
    For IP = 1 To NPAR
        CENVAL = 0#
        For IV = 1 To NVERT
            If IV <> IWorstV Then CENVAL = CENVAL + VERMAT(IV, IP)
        Next IV
        CENTRE(IP) = CENVAL / CDbl(NVERT - 1)
    Next IP
'
'
O400:   ' Riflessione:
    For IP = 1 To NPAR
        VERMAT(0, IP) = (1# + alfa) * CENTRE(IP) _
                      - alfa * VERMAT(IWorstV, IP)
    Next IP
    VERVAL(0) = VERCALC(0)
    If (VERVAL(0) >= VERVAL(IWorstV)) Then GoTo O600  ' -> Contrazione.
    NCC = 0
    OpS$ = "Riflessione"
    If (VERVAL(0) >= VERVAL(IBestV)) Then GoTo O800   ' -> Sostituzione
                                                      ' di IWORSTV con
                                                      ' IV0.
'
'
O500:   ' Riflessione Estesa:
    For IP = 1 To NPAR
        VERMAT(IWorstV, IP) = VERMAT(0, IP)
        VERMAT(0, IP) = (1# - GAMMA) * CENTRE(IP) _
                      + GAMMA * VERMAT(IWorstV, IP)
    Next IP
    VERVAL(IWorstV) = VERVAL(0)
    VERVAL(0) = VERCALC(0)
    If (VERVAL(0) >= VERVAL(IBestV)) Then GoTo O900   ' -> Exit Sub.
    OpS$ = "Riflessione Estesa"
    GoTo O800   ' -> Sostituzione di IWORSTV con IV0.
'
'
O600:   ' Contrazione:
    For IP = 1 To NPAR
        VERMAT(0, IP) = (1# - BETA) * CENTRE(IP) _
                      + BETA * VERMAT(IWorstV, IP)
    Next IP
    VERVAL(0) = VERCALC(0)
    If (VERVAL(0) >= VERVAL(IWorstV)) Then GoTo O700  ' -> Contrazione
                                                      ' Completa.
    NCC = 0
    OpS$ = "Contrazione"
'
'
O800:   ' Sostituzione di IWORSTV con IV0:
    For IP = 1 To NPAR
        VERMAT(IWorstV, IP) = VERMAT(0, IP)
    Next IP
    VERVAL(IWorstV) = VERVAL(0)
    GoTo O900   ' -> Exit Sub.
'
'
O700:   ' Contrazione Completa:
    For IV = 1 To NVERT
        If IV <> IBestV Then
            For IP = 1 To NPAR
                VERMAT(IV, IP) = (1# - DELTA) * VERMAT(IBestV, IP) _
                               + DELTA * VERMAT(IV, IP)
            Next IP
            VERVAL(IV) = VERCALC(IV)
        End If
    Next IV
    NCC = NCC + 1
    OpS$ = "Contrazione Completa"
'
'
O900:   ' Ricerca dei migliori e peggiori valori correnti:
    ValBV = VERVAL(1)
    ValWV = VERVAL(1)
    IBestV = 1
    IWorstV = 1
    For IV = 2 To NVERT
        If VERVAL(IV) < ValBV Then
            ValBV = VERVAL(IV)
            IBestV = IV
        End If
        If VERVAL(IV) > ValWV Then
            ValWV = VERVAL(IV)
            IWorstV = IV
        End If
    Next IV
    ValDf = ValWV - ValBV
'
    ' Ritorna i parametri del vertice migliore:
    IP = 0
    For IBP = LBound(BestP) To UBound(BestP)
        IP = IP + 1
        BestP(IBP) = VERMAT(IBestV, IP)
    Next IBP
'
'
'
End Sub
Sub SIMPLES(IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, _
    ByVal NFilt&, ByVal FPIn As Boolean, ParIn#(), _
    ByVal CProf&, Frq#(), Fx#(), WTX#())
'
'   Imposta le condizioni iniziali per le operazioni di SIMPLEX.
'   NFilt& e' il numero di parametri della funzione da minimizzare.
'   Ritorna i valori correnti di IBestV&, IWorstV&, ValBV#,
'   ValWV# e ValDf# da usare nelle chiamate successive di SIMPLEX.
'   Se FPIn = True, usa i dati del vettore ParIn#() per impostare
'   un valore iniziale, non casuale, dei parametri da trovare.
'   CProf&, Frq#(), Fx#(), WTX#() sono variabili specifiche
'   di questa versione.
'
    Dim IV&, IP&, IPIn&, NPar2&, Per#
    ReDim HSx#(0 To NFilt - 1)
    ReDim GRs#(0 To UBound(Frq)), FRs#(0 To UBound(Frq))
'
    NPAR = NFilt
    NVERT = NPAR + 1
'
    ReDim VERMAT#(0 To NVERT, 1 To NPAR)
    ReDim VERVAL#(0 To NVERT)
    ReDim CENTRE#(1 To NPAR)
'
    FrqSx() = Frq()
    FxSx() = Fx()
    WxSx() = WTX()
'
    Randomize 'Timer
    IPIn = LBound(ParIn)
    For IV = 1 To NVERT
        For IP = 1 To NPAR
            If IV = 1 And FPIn Then
                Per = ParIn(IPIn) / 10#
                VERMAT#(IV, IP) = ParIn(IPIn) '* RandU(-Per, Per)
                IPIn = IPIn + 1
            Else
                VERMAT(IV, IP) = RandU(-1, 1)
            End If
        Next IP
        VERVAL(IV) = VERCALC(IV)
    Next IV
'
    If CProf = 1 Or CProf = 2 Then
        NPar2 = Int(NPAR / 2)
        For IV = 1 To NVERT
            For IP = 1 To NPar2
                If CProf = 1 Then
                    ' Coefficienti simmetrici:
                    VERMAT(IV, NPAR - (IP - 1)) = VERMAT(IV, IP)
                Else
                    ' Coefficienti antisimmetrici:
                    VERMAT(IV, NPAR - (IP - 1)) = -VERMAT(IV, IP)
                End If
            Next IP
            VERVAL(IV) = VERCALC(IV)
        Next IV
    End If
'
    ' Ricerca dei migliori e peggiori valori correnti
    ' da passare alle chiamate successive di SIMPLEX:
    ValBV = VERVAL(1)
    ValWV = VERVAL(1)
    IBestV = 1
    IWorstV = 1
    For IV = 2 To NVERT
        If ValBV > VERVAL(IV) Then
            ValBV = VERVAL(IV)
            IBestV = IV
        End If
        If ValWV < VERVAL(IV) Then
            ValWV = VERVAL(IV)
            IWorstV = IV
        End If
    Next IV
    ValDf = ValWV - ValBV
'
'
'
End Sub


Private Sub SchemaMatrici()
'
'
'   Definizioni:
'   m             = Numero di parametri della funzione da minimizzare.
'   n             = m + 1 Numero di vertici del simplesso.
'   f(P1, .., Pm) = Funzione da minimizzare a m parametri.
'
'   Parametri:
'   P1, P2, .., Pm          sono le colonne di VERMAT() e gli elementi
'                           di CENTRE().
'   Vertici:
'   V0, V1, V2, V3, .., Vn  sono le righe di VERMAT() e gli elementi
'                           di VERVAL().
'
'   Matrici e Vettori:
'   VERMAT(0 To n, 1 To m):
'        P1   P2   ..   Pm
'       ---------------------
'   V0 | Px1  Px2  ...  Pxm
'   V1 | P11  P12  ...  P1m     Se, e.g.,
'   V2 | P21  P22  ...  P2m  <- V2 = IWORSTV = vertice da scartare
'   V3 | P31  P32  ...  P3m     nel calcolo di CENTRE(P):
'   .. | ...  ...  ...  ...
'   Vn | Pn1  Pn2  ...  Pnm
'
'   CENTRE(1 To m):
'   P1 | (P11 + P31 + ..., + Pn1)/(n - 1)
'   P2 | (P12 + P32 + ..., + Pn2)/(n - 1)
'   .. | (... + ... + ..., + ...)/(n - 1)
'   Pm | (P1m + P3m + ..., + Pnm)/(n - 1)
'
'
'   VERVAL(0 To n):
'   V0 | f(Px1, ..., Pxm)  = VERCALC(0)
'   V1 | f(P11, ..., P1m)  = VERCALC(1)
'   V2 | f(P21, ..., P2m)  = VERCALC(2)
'   V3 | f(P31, ..., P3m)  = VERCALC(3)
'   .. | f(..., ..., ...)  = VERCALC(.)
'   Vn | f(Pn1, ..., Pnm)  = VERCALC(n)
'
'
'
End Sub
