Attribute VB_Name = "modUtilita"
'============================================================
' Descrizione.....: Routines di utilita' per FiltCalc.
' Nome dei Files..: modUtilita.bas
' Data............: 13/06/1999
' Aggiornamento...: 31/03/2001
' Versione........: 1.1 a 32 bits.
' Sistema.........: Visual Basic 6.0 sotto Windows NT 4.0
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.it/flanguasco/
'============================================================
'
Option Explicit
'
'--- SysSep: ---------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDECIMAL& = &HE
'
'--- Remove Menu: ---------------------------------------------------------
Private Declare Function RemoveMenu Lib "USER32" (ByVal hMenu As Long, _
    ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "USER32" (ByVal hWnd As Long, _
    ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "USER32" (ByVal hWnd As Long) As Long
'
Private Const MF_REMOVE = &H1000&
Private Const MF_ENABLED = &H0&
Private Const MF_INSERT = &H0&
'
Private Const SC_CLOSE = &HF060&
Private Const SC_MINIMIZE = &HF020&
Private Const SC_MAXIMIZE = &HF030&
Private Const SC_RESTORE = &HF120&
Public Function DATAN2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x
'   come implementata dal FORTRAN.
'   E':    -PI < DATAN2 <= PI.
'
    Select Case X
        Case Is > 0#
        DATAN2 = Atn(Y / X)
'
        Case Is < 0#
        If Y >= 0# Then
            DATAN2 = Atn(Y / X) + PI
        ElseIf Y < 0# Then
            DATAN2 = Atn(Y / X) - PI
        End If
'
        Case Is = 0#
        DATAN2 = Sgn(Y) * PI / 2#
    End Select
'
'
'
End Function
Public Function DMAXVAL(dVet#()) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If dDMax < dVet(J) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function
Public Function DMINVAL(dVet#()) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If dDMin > dVet(J) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
Public Function DMIN1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vDMin > vD(J) Then vDMin = vD(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function DMAX1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function Quadro(ByVal Foglio As PictureBox, _
    ByVal X0#, ByVal Xn#, ByVal Y0#, ByVal Yn#, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx& = 1, Optional ByRef PxN_X!, Optional ByRef PxN_Y!, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False, _
    Optional ByRef SxMin!, Optional ByRef SxMax!, _
    Optional ByRef SyMin!, Optional ByRef SyMax!, _
    Optional ByVal RifCol& = vbGreen, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByRef tEsec!) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Parametri in ingresso:
'     Foglio:    PictureBox da scalare.
'     X0:        Valore minimo di ascissa da rappresentare.
'     Xn:        Valore massimo di ascissa da rappresentare.
'                Deve essere X0 <= Xn.
'     Y0:        Valore minimo di ordinata da rappresentare.
'     Yn:        Valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: Stringa di formato dei valori sull' asse X.
'     FormatVY$: Stringa di formato dei valori sull' asse Y.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   Titolo del grafico.
'     UnitaX$:   Unita' (o titolo) dell' asse X.
'     UnitaY$:   Unita' (o titolo) dell' asse Y.
'     AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'     RifCol:    Colore degli assi, dei valori e delle griglie di riferimento.
'     bGriglia:  Se True viene disegnata la griglia di riferimento:
'                se False viene fatta solo la scalatura di Foglio.
'    Parametri in uscita:
'     SxMin:     Valore minimo di ascissa rappresentata.
'     SxMax:     Valore massimo di ascissa rappresentata.
'     SyMin:     Valore minimo di ordinata rappresentata.
'     SyMax:     Valore massimo di ordinata rappresentata.
'     PxN_X:     Larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx [Pixels].
'     tEsec:     tempo impiegato a disegnare il quadro [s].
'
'   Rev. 25/03/2003
'
    Dim I&, XI!, D_X!, rrx!, YI!, D_Y!, rry!, TxW!, Txt$
    Dim QxMin!, QxMax!, QyMin!, QyMax!
'
    tEsec = Timer
    On Error GoTo Quadro_ERR
'
    ' Verifico la correttezza delle scale:
    If X0 > Xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If Y0 > Yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
'-------------------------------------------------------------------------------------
'   Calcolo del passo di grigliatura degli assi.
'
    Dim DYMin!
    Const ScRis& = 5                ' La risoluzione delle scale e' 10 ^ -ScRis.
    Const ScMin! = 10 ^ (1 - ScRis) ' Ampiezza min. delle scale X e Y.
    Const Log10! = 2.30258509299405 ' Log(10#)
'
    ' Imposto una scala minima
    ' per l' asse X:
    If Xn - X0 < ScMin Then
        X0 = X0 - ScMin / 2!
        Xn = Xn + ScMin / 2!
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = Xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, ScRis))
    Xn = rrx * Ceil(Round(Xn / rrx, ScRis))
    D_X = Xn - X0
    SxMin = X0
    SxMax = Xn
'
    ' Imposto una scala minima
    ' per l' asse Y:
    If Format$(Y0, FormatVY$) = Format$(Yn, FormatVY$) Then
        DYMin = 0.0001
        Do While Format$(Y0 - DYMin, FormatVY$) = Format$(Yn + DYMin, FormatVY$)
            DYMin = 2! * DYMin
        Loop
'
        Y0 = Y0 - 10! * DYMin
        Yn = Yn + 10! * DYMin
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = Yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, ScRis))
    Yn = rry * Ceil(Round(Yn / rry, ScRis))
    D_Y = Yn - Y0
    SyMin = Y0
    SyMax = Yn
'
'-------------------------------------------------------------------------------------
'   Calcola larghezza ed altezza dei bordi.
'
    Dim Bl!, Br!, Bb!, Bt!, BDen!
    Dim TxWs!, TxWd!, TxHt!, TxHb!
'
    ' Imposto i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Annullo le scale precedenti:
    Foglio.ScaleMode = vbPixels
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxWs = Foglio.TextWidth(Format$(Y0, FormatVY$) & "W")
    If TxWs < Foglio.TextWidth(Format$(Yn, FormatVY$) & "W") Then
        TxWs = Foglio.TextWidth(Format$(Yn, FormatVY$) & "W")
    End If
'
    ' Il bordo a destra deve essere sufficiente
    ' a contenere il valore Xn e l' etichetta UnitaX$:
    TxWd = (Foglio.TextWidth(Format$(Xn, FormatVX$)) / 2!) _
         + Foglio.TextWidth(UnitaX$ & "W")
'
    ' I bordi a sinistra ed a destra sono:
    BDen = D_X / (Foglio.ScaleWidth - TxWs - TxWd)
    Bl = TxWs * BDen
    Br = TxWd * BDen
'
    ' Il bordo sotto e' 2 volte l' altezza dei valori:
    TxHb = 2! * Abs(Foglio.TextHeight("H"))
'
    ' Il bordo sopra e' 2 volte l' altezza dei valori
    ' piu' l' altezza del titolo:
    Foglio.FontSize = 12
    TxHt = TxHb + Abs(Foglio.TextHeight(Titolo$))
'
    ' I bordi sopra e sotto sono:
    BDen = D_Y / (Abs(Foglio.ScaleHeight) + TxHb + TxHt)
    Bb = TxHb * BDen
    Bt = TxHt * BDen
'
'-------------------------------------------------------------------------------------
'   Imposta la scala e calcola i valori comuni.
'
    Dim Po4_X!, Po4_Y!, EstAx!, EstAy!
'
    ' Imposto i bordi orizzontali
    ' e verticali:
    QxMin = X0 - Bl
    QxMax = X0 + D_X + Br
    QyMin = Y0 - Bb
    QyMax = Y0 + D_Y + Bt
'
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
'
    ' Imposto la scala e cancello il Foglio:
    Foglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
    Foglio.Line (QxMin, QyMin)-(QxMax, QyMax), Foglio.BackColor, BF ' Questo e' piu' veloce
                                                                    ' di Foglio.Cls.
'
    ' Calcolo larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcolo larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)  ' Uso i [Points] perche' voglio dimensioni
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)  ' proporzionali a quelle dei caratteri.
'
    ' Estremita' degli assi X e Y:
    EstAx = (Xn + QxMax) / 2!
    EstAy = (Yn + QyMax) / 2!
'
    ' Verifico se e' richiesto il
    ' disegno della griglia:
    If Not bGriglia Then GoTo Fine
'
'-------------------------------------------------------------------------------------
'   Disegna assi, griglie e scrive i valori di scala.
'
    Foglio.FontSize = 8
    Foglio.DrawWidth = 1
    Foglio.DrawMode = vbCopyPen
    Foglio.ForeColor = RifCol
'
    ' Traccio la griglia verticale e scrivo
    ' i valori dell' asse X:
    Foglio.DrawStyle = vbDash
    For XI = X0 To Xn + 0.1 * rrx Step rrx
        Foglio.Line (XI, Y0)-(XI, Yn), RifCol
        Txt$ = Format$(XI, FormatVX$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        If Abs(XI - Val(ValC2D(Txt$))) < rrx / 10 Then
            Foglio.CurrentX = XI - Foglio.TextWidth(Txt$) / 2!
            Foglio.CurrentY = Y0 + Po4_Y / 2!
            Foglio.Print Txt$;
        End If
    Next XI
    ' Scrivo l' etichetta dell' asse X:
    If Len(UnitaX$) > 0 Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.CurrentY = Y0 + Po4_Y / 2!
        Foglio.Print UnitaX$;
    End If
    ' Traccio l' asse Y:
    If (X0 <= 0!) And (0! <= Xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, Y0)-(0!, EstAy), RifCol
        Foglio.Line (0!, EstAy)-(-Po4_X / 2!, Po4_Y + EstAy), RifCol
        Foglio.Line (0!, EstAy)-(Po4_X / 2!, Po4_Y + EstAy), RifCol
    End If
'
    ' Traccio la griglia orizzontale e scrivo
    ' i valori dell' asse Y:
    Foglio.DrawStyle = vbDash
    For YI = Y0 To Yn + 0.1 * rry Step rry
        Foglio.Line (X0, YI)-(Xn, YI), RifCol
        Txt$ = Format$(YI, FormatVY$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        'If Abs(YI - Val(ValC2VTxt$))) < rry / 10 Then
            Foglio.CurrentX = QxMin
            Foglio.CurrentY = YI - Foglio.TextHeight(Txt$) / 2!
            Foglio.Print Txt$;
        'End If
     Next YI
    ' Scrivo l' etichetta dell' asse Y:
    If Len(UnitaY$) > 0 Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QyMax
        Foglio.Print UnitaY$;
    End If
    ' Traccio l' asse X:
    If (Y0 <= 0!) And (0! <= Yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (X0, 0!)-(EstAx, 0!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, -Po4_Y / 2!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, Po4_Y / 2!), RifCol
    End If
'
'-------------------------------------------------------------------------------------
'   Scrive il titolo del grafico:
'
    Dim TitL!, TitT!, TitW!, TitH!
'
    If Len(Titolo$) > 0 Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifico che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglio:
        Else
            TitL = Foglio.ScaleLeft
            Txt$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Txt$)) / TitW)) & Txt$
        End If
        TitT = QyMax
        ' Cancello l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
Fine:
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, " Quadro/" & Err.Source
    End If
    tEsec = Timer - tEsec
'
'
'
End Function
Public Function LinTodB(ByVal Y#) As Double
'
'   Trasforma, sull' asse Y, una posizione da Lineare a Logaritmica.
'   LinTodB(1) = 0 [dB],  LinTodB(0.1) = -20 [dB]
'
    If Y > 0# Then
        LinTodB = 20# * Log(Y) / Log10
    Else
        LinTodB = -9999#
    End If
'
'
'
End Function
Public Function LinToLog(ByVal X#, Optional ByVal BASE# = 10#) As Double
'
'   Trasforma una posizione da Lineare a Logaritmica.
'
    If X > 0# Then
        LinToLog = Log(X) / Log(BASE)
    Else
        LinToLog = -9999#
    End If
'
'
'
End Function
Public Function dBToLin(ByVal Y#) As Double
'
'   Trasforma, sull' asse Y, una posizione da Logaritmica a Lineare.
'   dBToLin(0 [dB]) = 1,  dBToLin(-20 [dB]) = 0.1
'
    dBToLin = 10# ^ (Y / 20#)
'
'
'
End Function
Public Function LogToLin(ByVal X#, Optional ByVal BASE# = 10#) As Double
'
'   Trasforma una posizione da Logaritmica a Lineare.
'
    LogToLin = BASE ^ X
'
'
'
End Function
Public Sub CloseButtonDisable(ByVal frmF As Form)
'
'
    Dim R1&
'
    R1 = RemoveMenu(GetSystemMenu(frmF.hWnd, 0), SC_CLOSE, MF_REMOVE)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$, _
    Optional ByVal MAXFIL& = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim A$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        A$ = mnuRecenti(F).Caption
        If UCase$(Right$(A$, Len(A$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        A$ = mnuRecenti(I - 1).Caption
        A$ = "&" & Trim$(Str$(I)) & " " & Right$(A$, Len(A$) - 3)
        mnuRecenti(I).Caption = A$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$, _
    Optional ByVal MAXFIL& = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge i files recenti dal Registry di Windows e li aggiunge
'   al menu mnuRecenti(). Se VerificaFE = True verifica anche
'   l' esistenza dei files da aggiungere:
'
    Dim I&, FileRec$
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If FileRec$ <> "" Then
            If VerificaFE Then
                If FileExists(FileRec$) Then AggiornaFilesRecenti mnuRecenti, FileRec$
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva i files recenti, contenuti nel menu mnuRecenti(),
'   nel Registry di Windows:
'
    Dim I&, FileRec$
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Function CMDialog_Files(ByVal CMDialog As CommonDialog, ByVal Oper$, _
    ByVal Tipo$, ByVal Ext$, Optional ByVal DirNome$ = "", _
    Optional ByVal FileNome$ = "", Optional ByVal Titolo$ = "") As String
'
'   Imposta i valori di una finestra per la gestione dei Files
'   e ritorna il nome completo del File scelto.
'   La gestione degli errori (e.g. cdlCancel) va' fatta nella
'   routine chiamante.
'
'   Parametri:
'    CMDialog:  e' il controllo Common Dialog che si intende usare.
'    Oper$:     operazione da eseguire (solo "Save" o "Open").
'    Tipo$:     tipo dei files da proporre.
'    Ext$:      estensioni dei files da proporre (e.g. "*.dat[;*.txt]").
'    DirNome$:  Folder di default.
'    FileNome$: nome del File di default.
'    Titolo$:   titolo della finestra.
'
    Dim Filter$
'
    If Oper$ <> "Open" And Oper$ <> "Save" Then Err.Raise 5
'
    ' Prepara ed imposta tipo ed estensioni dei
    ' files da proporre:
    Filter$ = Tipo$ & " (" & Ext$ & ")|" & Ext$ & "|"
    Filter$ = Filter$ & "Tutti i Files (*.*)|*.*"
    CMDialog.Filter = Filter$
    CMDialog.FilterIndex = 1
'
    ' Imposta il Folder di default:
    If DirNome$ <> "" Then
        CMDialog.InitDir = DirNome$
    Else
        CMDialog.InitDir = App.Path
    End If
'
    ' Imposta il File Name di default:
    If FileNome$ <> "" Then
        CMDialog.FileName = FileNome$
    Else
        If Oper$ = "Open" Then
            CMDialog.FileName = ""
        ElseIf Oper$ = "Save" Then
            CMDialog.FileName = Left$(Ext$, 5)
        End If
    End If
'
    ' Scrive il titolo della finestra:
    CMDialog.DialogTitle = " " & Titolo$
'
    ' Controlla l' esistenza del File, chiede conferma
    ' se File Already Exists, nasconde la casella Read Only:
    CMDialog.Flags = cdlOFNFileMustExist + cdlOFNOverwritePrompt _
                   + cdlOFNHideReadOnly
    ' e permette il Cancel:
    CMDialog.CancelError = True
'
    ' Apre la finestra con
    ' l' operazione richiesta:
    If Oper$ = "Open" Then
        CMDialog.ShowOpen
    ElseIf Oper$ = "Save" Then
        CMDialog.ShowSave
    End If
'
    CMDialog_Files = CMDialog.FileName
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
    Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(ByRef DS$, Optional ByRef MS$)
'
'   Trova i separatori decimale e
'   delle migliaia del sistema:
'
    DS$ = "  "
    MS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
'
'
'
End Sub
Public Function FormatE$(ByVal vNum As Variant, Optional ByVal strF$ = "0.0#####E-00")
'
'   Ritorna il valore vNum in formato scientifico
'   ingegneristico (i.e. con esponente multiplo di 3):
'
    Dim FTemp$, MEsp&
'
    strF$ = UCase$(strF$)
    If Left$(strF$, 1) = "+" Or Left$(strF$, 1) = "-" Then
        strF$ = Mid$(strF$, 2)
    End If
'
    FTemp$ = Format$(vNum, strF$)
    MEsp = Val(Mid$(FTemp$, InStr(FTemp$, "E") + 1)) Mod 3
'
    If MEsp > 0 Then
        strF$ = String(MEsp, "#") & strF$
    ElseIf MEsp < 0 Then
        strF$ = String(3 - Abs(MEsp), "#") & strF$
    End If
'
    FormatE$ = Format$(vNum, strF$)
'
'
'
End Function

Public Function Acos(ByVal X As Double) As Double
'
'   Calcola l' ArcoCoseno di x con -1 <= x <= 1.
'   Acos e' in radianti.
'
    If 0# < X And X <= 1# Then
        Acos = Atn(Sqr(1# - X * X) / X)
    ElseIf -1# <= X And X < 0# Then
        Acos = PI + Atn(Sqr(1# - X * X) / X)
    ElseIf X = 0# Then
        Acos = PI / 2#
    Else
        Err.Raise 5, "Acos Function", "Argomento illegale per Acos"
    End If
'
'
'
End Function
Public Function Asin(ByVal X As Double) As Double
'
'   Calcola l' ArcoSeno di x con -1 <= x <= 1.
'   Asin e' in radianti.
'
    If Abs(X) < 1# Then
        Asin = Atn(X / Sqr(1# - X * X))
    ElseIf X = 1# Then
        Asin = PI / 2#
    ElseIf X = -1# Then
        Asin = -PI / 2#
    Else
        Err.Raise 5, "Asin Function", "Argomento illegale per Asin"
    End If
'
'
'
End Function

Public Function Atan2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente su 4 Quadranti.
'   E':    0 <= Atan2 < 2 * PI.
'
    Select Case X
    Case Is > 0#
        Atan2 = IIf(Y >= 0#, Atn(Y / X), Atn(Y / X) + PI2)
'
    Case Is < 0#
        Atan2 = Atn(Y / X) + PI
'
    Case Is = 0#
        Atan2 = PI * Sgn(Y) / 2#
    End Select
'
'
'
End Function
Public Function RandN(ByVal VMedio!, ByVal Sigma!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione normale:
'
    Dim E!, I&
'
    E = 0!
    For I = 1 To 12
        E = E + Rnd
    Next I
'
    RandN = VMedio + Sigma * (E - 6!)
'
'
'
End Function
Public Function RandR(ByVal Sigma!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione di Rayleigh:
'
    RandR = Sqr(-2! * Sigma * Sigma * Log(1! - Rnd))
'
'
'
End Function
Public Function RandU(ByVal V_Min!, ByVal V_Max!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function
Public Function MIN0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vDMin > vD(J) Then vDMin = vD(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function MAX0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA%, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    'Dim TextB As TextBox    ' Solo per TextBoxes.
    Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
    Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If X = Int(X) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function

Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I&
'
    For I = 0 To Forms.Count - 1
        If Forms(I) Is frmF Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef PName$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'   Full$  = Nome completo del File.
'   PName$ = Path del File (con \ finale).
'   FName$ = Nome del File con Estensione.
'   Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Sub Swap(ByRef vN1 As Variant, ByRef vN2 As Variant)
'
'
    Dim vTn As Variant
'
    vTn = vN1
    vN1 = vN2
    vN2 = vTn
'
'
'
End Sub
Public Sub LeggiPosizioneForm(ByVal frmF As Form, ByRef frmF_Left&, ByRef frmF_Top&, _
    Optional ByRef frmF_Width&, Optional ByRef frmF_Height&)
'
'   Legge, se e' definito il "Product Name" del progetto, la posizione
'   iniziale e le dimensioni  del Form frmF memorizzate sul Registry di Window.
'   Da usare nell' evento frmF_Load:
'
    If App.ProductName <> "" Then
        frmF_Left = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Left", 0))
        frmF_Top = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Top", 0))
'
        frmF_Width = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Width", Screen.Width))
        frmF_Height = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Height", Screen.Height))
    Else
        frmF_Left = 0
        frmF_Top = 0
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
'
'
End Sub
Public Sub SalvaPosizioneForm(ByVal frmF As Form, _
    Optional ByVal Dimensioni As Boolean = False)
'
'   Salva, sul Registry di Window e se e' definito il
'   "Product Name" del progetto, la posizione finale
'   del Form frmF.  Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    If (frmF.WindowState <> vbMinimized) And (App.ProductName <> "") Then
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Left", frmF.Left
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Top", frmF.Top
'
        If Dimensioni Then
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Width", frmF.Width
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Sub Stat_F(ByVal FileN$, _
    Optional ByRef dVMin#, Optional ByRef dVMax#, _
    Optional ByRef dVMedio#, Optional ByRef dDevStd#, _
    Optional ByRef lNVal&, Optional ByRef dSVal#)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel file FileN$:
'
    Dim FF%, dVal#, dSValQ#, M$
'
    On Error GoTo Stat_F_ERR
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    On Error GoTo Stat_F_ERR
'
    dVMin = 1E+300
    dVMax = -1E+300
    lNVal = 0
    dSVal = 0#
'
    Do While Not EOF(FF)
        Input #FF, dVal
        lNVal = lNVal + 1
        If dVMin > dVal Then dVMin = dVal
        If dVMax < dVal Then dVMax = dVal
        dSVal = dSVal + dVal
        dSValQ = dSValQ + dVal * dVal
    Loop
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_F_ERR:
    Close #FF
    If (Err <> 0) Then
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If lNVal < 2 Then M$ = M$ & "Il File dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " Errore in Stat_F"
    End If
'
'
'
End Sub
Public Sub Stat_V(dVal() As Double, _
    Optional ByRef dVMin#, Optional ByRef dVMax#, _
    Optional ByRef dVMedio#, Optional ByRef dDevStd#, _
    Optional ByRef lNVal&, Optional ByRef dSVal#)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel vettore dVal():
'
    Dim I&, dSValQ#, M$
'
    On Error GoTo Stat_V_ERR
'
    lNVal = UBound(dVal) - LBound(dVal) + 1
    If lNVal < 2 Then Err.Raise 5
'
    dVMin = dVal(LBound(dVal))
    dVMax = dVal(LBound(dVal))
    dSVal = dVMin
    dSValQ = dVMin * dVMin
'
    For I = LBound(dVal) + 1 To UBound(dVal)
        If dVMin > dVal(I) Then dVMin = dVal(I)
        If dVMax < dVal(I) Then dVMax = dVal(I)
        dSVal = dSVal + dVal(I)
        dSValQ = dSValQ + dVal(I) * dVal(I)
    Next I
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_V_ERR:
    If (Err <> 0) Then
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If lNVal < 2 Then M$ = M$ & "Il File dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " Errore in Stat_V"
    End If
'
'
'
End Sub



Public Function ValC2D(ByVal sNum$) As String
'
'   Sostituisce, nella stringa numerica sNum$,
'   la "," con il ".".  Rende cosi' possibile
'   usare la funzione Val su testi che usino la
'   "," come separatore decimale.
'
    ValC2D = Replace(sNum$, ",", ".")
'
'
'
End Function
